// ___SETA43  _____
// 18/02/2019 _____
//_NAVIDAD V2 _____

//Digispark Arduino
//Create a file named /etc/udev/rules.d/digispark.rules  with the following line in it:
//SUBSYSTEM=="usb", ATTR{idVendor}=="16d0", ATTR{idProduct}=="0753", MODE="0660", GROUP="dialout"


#define DEBUG  0    //para cambiar entre cosola y no consola.
                    //En el caso de Digispark no sirve

//Arduino version 1.85  
//Sin consola serie 1736 bytes


#define SALIDA1  0
#define SALIDA2  1
#define ENTRADA  2


#define TIEMPO0  10
#define TIEMPO2  50
#define TIEMPO3  25
#define TIEMPO4  12

int tiempo0,tiempo2,tiempo3,tiempo4;
int f1;

int brillo,pasosBrillo=20,pasosBrillo2=1000;
int mode=6,modex;

unsigned char secuenciaA1[10]={255,0,255,0,0,0,0,0,0,0};
unsigned char secuenciaB1[10]={0,0,0,255,255,255,255,0,0,0};

unsigned char secuenciaA2[10]={0xFF,0x00,0xFF,0x00,0xFF,0x00,0x00,0x00,0x00,0x00};
unsigned char secuenciaB2[10]={0x00,0x00,0x00,0x00,0x00,0xFF,0xFF,0xFF,0x00,0x00};

int z;
 
void setup() 
{                
  pinMode(SALIDA1, OUTPUT);
  pinMode(SALIDA2, OUTPUT);  
  pinMode(ENTRADA, INPUT);
#if DEBUG==1 
  Serial.begin(9600);
#endif  
}


void SetLED(int a,int b)
{
      analogWrite(SALIDA1, a);
      analogWrite(SALIDA2, b);
#if DEBUG==1       
     Serial.print(a);     Serial.print("  ");     Serial.println(b);
#endif     
}  
 
void testF1(void)
{
      if(f1==0)
        { f1=1;    SetLED(255,0);}
      else
        { f1=0;    SetLED(0,255);}
}

void testBrillo(int pasos)
{
      if(brillo<-50)  pasosBrillo=pasos; 
      if(brillo>300)  pasosBrillo=pasos*-1; 
      brillo=brillo+pasosBrillo; 
      z=brillo;
      if(z<0)   z=0;
      if(z>255) z=255;
      SetLED(z,255-z);
}



void loop() 
{ 
  delay(10);
  tiempo0--;   tiempo2--;  tiempo3--;  tiempo4--;

  if(HIGH==digitalRead(ENTRADA))
    {
      mode++;
      delay(300);
      z=0; pasosBrillo=100;    
    }

  if(modex!=mode) 
    { 
      modex=mode;
#if DEBUG==1     
      Serial.print("______MODE ");Serial.println(mode);
#endif      
    }

  switch(mode)
  {
    //_____________________________________________
    case 0:
    if(tiempo2<1)
    {
      tiempo2=TIEMPO2;
      testF1();
    } 
    break;
    //_____________________________________________
    case 1:
    if(tiempo3<1)
    {
      tiempo3=TIEMPO3;
      testF1();
    } 
    break;
    //_____________________________________________
    case 2:
    if(tiempo4<1)
    {
      tiempo4=TIEMPO4;
      testF1();
    } 
    break;
    //_____________________________________________
    case 3:
    if(tiempo4<1)
    {
     tiempo4=TIEMPO4;               
     testBrillo(5);
    } 
    break;
    //_____________________________________________
    case 4:
    if(tiempo4<1)
    {
     tiempo4=TIEMPO4;               
     testBrillo(15);
    } 
    break;
     //_____________________________________________
    case 5:
     if(tiempo4<1)
    {
     tiempo4=TIEMPO4;               
     testBrillo(30);
    } 
    break;
     //_____________________________________________
    case 6:
     if(tiempo0<0)
    {
     tiempo0=TIEMPO0;
     z++;  if(z>9) z=0;
     SetLED(secuenciaA1[z],secuenciaB1[z]);
    } 
    break;
       //_____________________________________________
    case 7:
     if(tiempo0<0)
    {
     tiempo0=TIEMPO0;
     z++;  if(z>9) z=0;
     SetLED(secuenciaA2[z],secuenciaB2[z]);
    } 
    break;
    //_____________________________________________
    default:
       mode=0;
    break;

  }

}
    
